﻿Imports System.Net
Imports System.Net.Sockets
Imports System.Threading

Public Class Form1

    Dim Listenthread As Thread
    Public nClients As Integer
    Public ServerRun As Boolean
    Public ListenSocket As Socket
    Public listener As TcpListener
    Public Delegate Sub DelegateSetText(ByVal text As String)
    Public Delegate Sub DelegateSetStatusText(ByVal text As String)


    Private Sub listen_thread()

        ListenSocket = Nothing
        Try
            listener = New TcpListener(IPAddress.Parse("0.0.0.0"), Integer.Parse(tb_port.Text))
            listener.Start()
            While ServerRun

                ListenSocket = listener.AcceptSocket()
                If (ListenSocket.Connected) Then

                    Dim newMultiServer As New MultiServer()
                    newMultiServer.NewConnection(ListenSocket, Me)
                End If
            End While

        Catch ex As Exception
        End Try

    End Sub

    Public Sub setStatusText(ByVal StatusText As String)
        If Me.InvokeRequired Then
            Me.Invoke(New DelegateSetStatusText(AddressOf setStatusText), StatusText)
        Else
            sb_status.Text = StatusText
        End If
    End Sub

    Public Sub setText(ByVal ReceiveText As String)

        If Me.InvokeRequired Then
            Me.Invoke(New DelegateSetText(AddressOf setText), ReceiveText)
        Else
            tb_receive.Text += ReceiveText
        End If

    End Sub

    Private Sub bt_listen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_listen.Click

        bt_listen.Enabled = False
        ServerRun = True
        Listenthread = New Thread(New ThreadStart(AddressOf listen_thread))
        Listenthread.Start()

    End Sub

    Private Sub bt_end_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_end.Click

        ServerRun = False
        Try
            listener.Stop()
            Listenthread.Abort()
        Catch ex As Exception
        End Try

        Try
            Application.Exit()
        Catch ex As Exception
        End Try

    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        Me.bt_end_Click(Me, Nothing)

    End Sub
End Class

Public Class MultiServer

    Dim ConnectionSocket As Socket
    Dim ConnectionSocketEP As IPEndPoint
    Dim IPString As String
    Dim Buffer(511) As Byte
    Dim stream As NetworkStream
    Dim ReceiveCallback As AsyncCallback
    Dim FormA As Form1

    Public Sub NewConnection(ByVal SockPar As Socket, ByVal newForm As Form1)

        FormA = newForm
        ConnectionSocket = SockPar
        ConnectionSocketEP = ConnectionSocket.RemoteEndPoint
        IPString = ConnectionSocketEP.ToString()
        stream = New NetworkStream(ConnectionSocket)
        ReceiveCallback = New AsyncCallback(AddressOf receive_callback)
        Try

            stream.BeginRead(Buffer, 0, Buffer.Length, ReceiveCallback, Nothing)
            FormA.nClients = FormA.nClients + 1
            FormA.SetStatusText("Clients connected: " + FormA.nClients.ToString())

        Catch ex As Exception
            closesock()
        End Try
    End Sub

    Public Sub receive_callback(ByVal ar As IAsyncResult)

        Try

            Dim nRead As Integer = 0
            nRead = stream.EndRead(ar)
            If (nRead > 0) Then

                stream.BeginRead(Buffer, 0, Buffer.Length, ReceiveCallback, Nothing)
                FormA.SetText(IPString + ":" + System.Text.Encoding.ASCII.GetString(Buffer, 0, nRead))

            Else
                closesock()
            End If

        Catch ex As Exception

            closesock()
        End Try
    End Sub

    Public Sub closesock()

        FormA.nClients = FormA.nClients - 1
        FormA.setStatusText("Clients connected: " + FormA.nClients.ToString())
        Try

            stream.Close()

        Catch ex As Exception
        End Try

        ConnectionSocket.Shutdown(SocketShutdown.Both)
        ConnectionSocket.Close()
    End Sub
End Class
